## uriparser 0.9.4+dfsg

=== CMakeLists.txt ===
# uriparser - RFC 3986 URI parsing library
#
# Copyright (C) 2018, Sebastian Pipping <sebastian@pipping.org>
# All rights reserved.
#
# Redistribution and use in source  and binary forms, with or without
# modification, are permitted provided  that the following conditions
# are met:
#
#     1. Redistributions  of  source  code   must  retain  the  above
#        copyright notice, this list  of conditions and the following
#        disclaimer.
#
#     2. Redistributions  in binary  form  must  reproduce the  above
#        copyright notice, this list  of conditions and the following
#        disclaimer  in  the  documentation  and/or  other  materials
#        provided with the distribution.
#
#     3. Neither the  name of the  copyright holder nor the  names of
#        its contributors may be used  to endorse or promote products
#        derived from  this software  without specific  prior written
#        permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND  ANY EXPRESS OR IMPLIED WARRANTIES,  INCLUDING, BUT NOT
# LIMITED TO,  THE IMPLIED WARRANTIES OF  MERCHANTABILITY AND FITNESS
# FOR  A  PARTICULAR  PURPOSE  ARE  DISCLAIMED.  IN  NO  EVENT  SHALL
# THE  COPYRIGHT HOLDER  OR CONTRIBUTORS  BE LIABLE  FOR ANY  DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO,  PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA,  OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT  LIABILITY,  OR  TORT (INCLUDING  NEGLIGENCE  OR  OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#
cmake_minimum_required(VERSION 3.3)

project(uriparser
    VERSION
        0.9.4
    LANGUAGES
        C
)

# See https://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html
set(URIPARSER_SO_CURRENT    1)
set(URIPARSER_SO_REVISION  27)
set(URIPARSER_SO_AGE        0)

include(CheckCCompilerFlag)
include(CheckFunctionExists)
include(CheckLibraryExists)
include(CheckSymbolExists)
include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

#
# Configuration
#
option(BUILD_SHARED_LIBS "Build shared libraries (rather than static ones)" ON)
option(URIPARSER_BUILD_DOCS "Build API documentation (requires Doxygen, Graphviz, and (optional) Qt's qhelpgenerator)" ON)
option(URIPARSER_BUILD_TESTS "Build test suite (requires GTest >=1.8.0)" ON)
option(URIPARSER_BUILD_TOOLS "Build tools (e.g. CLI \"uriparse\")" ON)
option(URIPARSER_BUILD_CHAR "Build code supporting data type 'char'" ON)
option(URIPARSER_BUILD_WCHAR_T "Build code supporting data type 'wchar_t'" ON)
option(URIPARSER_ENABLE_INSTALL "Enable installation of uriparser" ON)
set(URIPARSER_MSVC_RUNTIME "" CACHE STRING "Use of specific runtime library (/MT /MTd /MD /MDd) with MSVC")

if(NOT URIPARSER_BUILD_CHAR AND NOT URIPARSER_BUILD_WCHAR_T)
    message(SEND_ERROR "One or more of URIPARSER_BUILD_CHAR and URIPARSER_BUILD_WCHAR_T needs to be enabled.")
endif()
if(URIPARSER_BUILD_TESTS AND NOT (URIPARSER_BUILD_CHAR AND URIPARSER_BUILD_WCHAR_T))
    message(SEND_ERROR "URIPARSER_BUILD_TESTS=ON requires both URIPARSER_BUILD_CHAR=ON and URIPARSER_BUILD_WCHAR_T=ON.")
endif()
if(URIPARSER_BUILD_TOOLS AND NOT URIPARSER_BUILD_CHAR)
    message(SEND_ERROR "URIPARSER_BUILD_TOOLS=ON requires URIPARSER_BUILD_CHAR=ON.")
endif()

macro(uriparser_apply_msvc_runtime_to ref)
    string(REGEX REPLACE "/M[DT]d?" ${URIPARSER_MSVC_RUNTIME} ${ref} "${${ref}}")
endmacro()

if(MSVC AND URIPARSER_MSVC_RUNTIME)
    uriparser_apply_msvc_runtime_to(CMAKE_C_FLAGS)
    uriparser_apply_msvc_runtime_to(CMAKE_C_FLAGS_DEBUG)
    uriparser_apply_msvc_runtime_to(CMAKE_C_FLAGS_RELEASE)
endif()

macro(uriparser_install)
    if(URIPARSER_ENABLE_INSTALL)
        install(${ARGN})
    endif()
endmacro()

#
# Compiler checks
#
set(URIPARSER_EXTRA_COMPILE_FLAGS)

check_c_compiler_flag("-fvisibility=hidden" URIPARSER_COMPILER_SUPPORTS_VISIBILITY)
if(URIPARSER_COMPILER_SUPPORTS_VISIBILITY)
    set(URIPARSER_EXTRA_COMPILE_FLAGS "${URIPARSER_EXTRA_COMPILE_FLAGS} -fvisibility=hidden")
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${URIPARSER_EXTRA_COMPILE_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${URIPARSER_EXTRA_COMPILE_FLAGS}")

#
# config.h
#
check_symbol_exists(wprintf wchar.h HAVE_WPRINTF)
check_function_exists(reallocarray HAVE_REALLOCARRAY)  # no luck with CheckSymbolExists
configure_file(src/UriConfig.h.in config.h)

#
# C library
#
set(API_HEADER_FILES
    include/uriparser/UriBase.h
    include/uriparser/UriDefsAnsi.h
    include/uriparser/UriDefsConfig.h
    include/uriparser/UriDefsUnicode.h
    include/uriparser/Uri.h
    include/uriparser/UriIp4.h
)
set(LIBRARY_CODE_FILES
    src/UriCommon.c
    src/UriCommon.h
    src/UriCompare.c
    src/UriEscape.c
    src/UriFile.c
    src/UriIp4Base.c
    src/UriIp4Base.h
    src/UriIp4.c
    src/UriMemory.c
    src/UriMemory.h
    src/UriNormalizeBase.c
    src/UriNormalizeBase.h
    src/UriNormalize.c
    src/UriParseBase.c
    src/UriParseBase.h
    src/UriParse.c
    src/UriQuery.c
    src/UriRecompose.c
    src/UriResolve.c
    src/UriShorten.c
)

add_library(uriparser
    ${API_HEADER_FILES}
    ${LIBRARY_CODE_FILES}
)

if(NOT MSVC)
    math(EXPR URIPARSER_SO_CURRENT_MINUS_AGE "${URIPARSER_SO_CURRENT} - ${URIPARSER_SO_AGE}")
    set_property(TARGET uriparser PROPERTY VERSION ${URIPARSER_SO_CURRENT_MINUS_AGE}.${URIPARSER_SO_AGE}.${URIPARSER_SO_REVISION})
    set_property(TARGET uriparser PROPERTY SOVERSION ${URIPARSER_SO_CURRENT_MINUS_AGE})
    if(WIN32)
        set_property(TARGET uriparser PROPERTY SUFFIX "-${URIPARSER_SO_CURRENT_MINUS_AGE}${CMAKE_SHARED_LIBRARY_SUFFIX}")
    endif()
endif()

set_property(
    TARGET
        uriparser
    PROPERTY
        PUBLIC_HEADER "${API_HEADER_FILES}"
)

target_compile_definitions(uriparser PRIVATE URI_LIBRARY_BUILD)
if (NOT BUILD_SHARED_LIBS)
    target_compile_definitions(uriparser PUBLIC URI_STATIC_BUILD)
endif()
if(NOT URIPARSER_BUILD_CHAR)
    target_compile_definitions(uriparser PUBLIC URI_NO_ANSI)
endif()
if(NOT URIPARSER_BUILD_WCHAR_T)
    target_compile_definitions(uriparser PUBLIC URI_NO_UNICODE)
endif()
if(URIPARSER_COMPILER_SUPPORTS_VISIBILITY)
    target_compile_definitions(uriparser PRIVATE URI_VISIBILITY)
endif()

target_include_directories(uriparser
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    PRIVATE
        ${CMAKE_CURRENT_BINARY_DIR}  # for config.h
)

uriparser_install(
    TARGETS
        uriparser
    EXPORT
        uriparser
    ARCHIVE
        DESTINATION
            ${CMAKE_INSTALL_LIBDIR}
    LIBRARY
        DESTINATION
            ${CMAKE_INSTALL_LIBDIR}
    RUNTIME
        DESTINATION
            ${CMAKE_INSTALL_BINDIR}
    PUBLIC_HEADER
        DESTINATION
            ${CMAKE_INSTALL_INCLUDEDIR}/uriparser
)

#
# C command line tool
#
if(URIPARSER_BUILD_TOOLS)
    add_executable(uriparse
        tool/uriparse.c
    )

    target_link_libraries(uriparse PUBLIC uriparser)

    if(HAIKU)
        # Function inet_ntop needs -lsocket or -lnetwork (see pull request #45)
        check_library_exists(socket inet_ntop "" HAVE_LIBSOCKET__INET_NTOP)
        check_library_exists(network inet_ntop "" HAVE_LIBNETWORK__INET_NTOP)
        if(HAVE_LIBSOCKET__INET_NTOP)
            target_link_libraries(uriparse PUBLIC socket)
        endif()
        if(HAVE_LIBNETWORK__INET_NTOP)
            target_link_libraries(uriparse PUBLIC network)
        endif()
    endif()

    if(WIN32)
        target_link_libraries(uriparse PUBLIC ws2_32)
    endif()

    uriparser_install(
        TARGETS
            uriparse
        DESTINATION
            ${CMAKE_INSTALL_BINDIR}
    )
endif()

#
# C++ test runner
#
if(URIPARSER_BUILD_TESTS)
    enable_language(CXX)

    if(MSVC AND URIPARSER_MSVC_RUNTIME)
        uriparser_apply_msvc_runtime_to(CMAKE_CXX_FLAGS)
        uriparser_apply_msvc_runtime_to(CMAKE_CXX_FLAGS_DEBUG)
        uriparser_apply_msvc_runtime_to(CMAKE_CXX_FLAGS_RELEASE)
    endif()

    enable_testing()

    find_package(GTest 1.8.0 REQUIRED)

    add_executable(testrunner
        test/FourSuite.cpp
        test/MemoryManagerSuite.cpp
        test/test.cpp
        test/VersionSuite.cpp

        # These library code files have non-public symbols that the test suite
        # needs to link to, so they appear here as well:
        ${API_HEADER_FILES}
        ${LIBRARY_CODE_FILES}
    )

    target_compile_definitions(testrunner PRIVATE URI_STATIC_BUILD)

    if(MSVC)
        target_compile_definitions(testrunner PRIVATE -D_CRT_SECURE_NO_WARNINGS)
    endif()

    target_include_directories(testrunner SYSTEM PRIVATE
        ${GTEST_INCLUDE_DIRS}
    )

    target_include_directories(testrunner PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}/include
        ${CMAKE_CURRENT_BINARY_DIR}  # for config.h
    )

    target_link_libraries(testrunner PUBLIC
        ${GTEST_BOTH_LIBRARIES}
    )

    add_test(
        NAME
            test
        COMMAND
            testrunner
    )

    add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})
endif()

#
# Doxygen API documentation
#
if(URIPARSER_BUILD_DOCS)
    find_package(Doxygen REQUIRED dot doxygen)
    find_program(QHG_LOCATION
        NAMES
            qhelpgenerator
            qhelpgenerator-qt5  # e.g. CentOS 7
    )
    include(FindHTMLHelp)

    # Generate Doxyfile
    if(HTML_HELP_COMPILER)
        set(GENERATE_HTMLHELP YES)
    else()
        set(GENERATE_HTMLHELP NO)
    endif()
    if(QHG_LOCATION)
        set(GENERATE_QHP YES)
    else()
        set(GENERATE_QHP NO)
    endif()
    configure_file(doc/Doxyfile.in doc/Doxyfile @ONLY)
    configure_file(doc/release.sh.in doc/release.sh @ONLY)

    add_custom_target(doc
        ALL
        COMMAND
            ${DOXYGEN_EXECUTABLE}
            Doxyfile
        WORKING_DIRECTORY
            ${CMAKE_CURRENT_BINARY_DIR}/doc
        COMMENT
            "Generating API documentation with Doxygen"
        VERBATIM
    )

    uriparser_install(
        DIRECTORY
            ${CMAKE_CURRENT_BINARY_DIR}/doc/html
        DESTINATION
            ${CMAKE_INSTALL_DOCDIR}
    )
    if(QHG_LOCATION)
        uriparser_install(
            FILES
                ${CMAKE_CURRENT_BINARY_DIR}/doc/uriparser-${PROJECT_VERSION}.qch
            DESTINATION
                ${CMAKE_INSTALL_DOCDIR}
        )
    endif()
endif()

#
# CMake files for find_package(uriparser [..] CONFIG [..])
#
configure_package_config_file(
        cmake/uriparser-config.cmake.in
        cmake/uriparser-config.cmake
    INSTALL_DESTINATION
        ${CMAKE_INSTALL_LIBDIR}/cmake/uriparser-${PROJECT_VERSION}/
)
write_basic_package_version_file(
    cmake/uriparser-config-version.cmake
    COMPATIBILITY SameMajorVersion  # i.e. semver
)
export(
    TARGETS
        uriparser
    FILE
        cmake/uriparser-targets.cmake  # not going to be installed
)
uriparser_install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/cmake/uriparser-config.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/cmake/uriparser-config-version.cmake
    DESTINATION
        ${CMAKE_INSTALL_LIBDIR}/cmake/uriparser-${PROJECT_VERSION}/
)
uriparser_install(
    EXPORT
        uriparser
    DESTINATION
        ${CMAKE_INSTALL_LIBDIR}/cmake/uriparser-${PROJECT_VERSION}/
    NAMESPACE
        uriparser::
)

#
# pkg-config file
#
if(NOT MSVC)
    configure_file(liburiparser.pc.in liburiparser.pc @ONLY)
    uriparser_install(
        FILES
            ${CMAKE_CURRENT_BINARY_DIR}/liburiparser.pc
        DESTINATION
            ${CMAKE_INSTALL_LIBDIR}/pkgconfig/
    )
endif()

#
# Summary
#
message(STATUS "===========================================================================")
message(STATUS "")
message(STATUS "Configuration")
message(STATUS "  Prefix ............... ${CMAKE_INSTALL_PREFIX}")

=== debian/changelog ===
uriparser (0.9.4+dfsg-1+deb11u1) bullseye-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * UriNormalize.c: Fix .hostText copying in uriMakeOwnerEngine
    (CVE-2021-46141)
  * UriParse.c: Adjust uriFreeUriMembers* to fixed uriMakeOwner* behavior
    (CVE-2021-46141)
  * UriNormalize.c: Fix handling of empty segments in uriPreventLeakage
    (CVE-2021-46142)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 23 Jan 2022 16:13:58 +0100

uriparser (0.9.4+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Refresh patch.
    - Refresh symbols file.
  * Declare compliance with Debian Policy 4.5.0 (No changes needed).
  * Migrate to debhelper-compat 13:
    - Remove debian/compat.
    - Bump minimum debhelper-compat version in debian/control to = 13.
    - New debian/not-installed:
      + Add all files of dh_missing errors.
  * Add suffix +dfsg to changelog version number to make lintian happy.
  * debian/watch:
    - Add +dsfg stuff.
  * debian/control:
    - Add Rules-Requires-Root: no.
  * debian/copyright:
    - Add year 2020 to myself.
  * debian/not-installed:
    - Remove architecture specific path.

 -- Jörg Frings-Fürst <debian@jff.email>  Sat, 17 Oct 2020 19:26:34 +0200

=== debian/control ===
Source: uriparser
Section: libs
Priority: optional
Maintainer: Jörg Frings-Fürst <debian@jff.email>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-exec (>=0.3),
 doxygen,
 graphviz,
 libgtest-dev,
 libqt5sql5-sqlite,
 qtbase5-dev,
 qttools5-dev-tools
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: http://uriparser.sourceforge.net
Vcs-Git: git://jff.email/opt/git/uriparser.git
Vcs-Browser: https://jff.email/cgit/uriparser.git

Package: liburiparser1
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Pre-Depends:
 ${misc:Pre-Depends}
Description: URI parsing library compliant with RFC 3986
 uriparser is a library that parses Uniform Resource Identifiers (URIs),
 strictly adhering to RFC 3986 where syntax for URIs is defined. URIs
 are used to identify resources, like http://www.debian.org/ or
 urn:isbn:0-395-36341-1.
 .
 uriparser has the following features:
 .
  * strictly compliant to RFC 3986, implementing:
    + parsing
    + reference resolution
    + reference creation
    + recomposition
    + syntax-based normalization
  * fast (linear input length time complexity)
  * unicode support

Package: liburiparser-dev
Architecture: any
Section: libdevel
Depends:
 liburiparser1 (= ${binary:Version}),
 ${misc:Depends}
Description: development files for uriparser
 This package provides the development files for uriparser, a library to parse
 Uniform Resource Identifiers (URIs). Install it if you want to compile a
 program that makes use of this library.

Package: liburiparser-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends}
Description: documentation files for uriparser
 uriparser is a library that parses Uniform Resource Identifiers (URIs),
 strictly adhering to RFC 3986 where syntax for URIs is defined. URIs
 are used to identify resources, like http://www.debian.org/ or
 urn:isbn:0-395-36341-1.  This package provides the documentation
 files for uriparser.

=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg(.*)//,repacksuffix=+dfsg,uversionmangle=s/_/./g;s/\.(rc\d*)$/~$1/,compression=xz \
  https://github.com/uriparser/uriparser/releases \
  .*[^n]/(?:|v|version-|version|release-|r|REL_|rel-|uriparser(?:_|-))(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)

## uriparser 0.9.5+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -38,14 +38,14 @@
 
 project(uriparser
     VERSION
-        0.9.4
+        0.9.5
     LANGUAGES
         C
 )
 
-# See https://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html
+# See https://verbump.de/ for what these numbers do
 set(URIPARSER_SO_CURRENT    1)
-set(URIPARSER_SO_REVISION  27)
+set(URIPARSER_SO_REVISION  28)
 set(URIPARSER_SO_AGE        0)
 
 include(CheckCCompilerFlag)
@@ -65,6 +65,7 @@
 option(URIPARSER_BUILD_CHAR "Build code supporting data type 'char'" ON)
 option(URIPARSER_BUILD_WCHAR_T "Build code supporting data type 'wchar_t'" ON)
 option(URIPARSER_ENABLE_INSTALL "Enable installation of uriparser" ON)
+option(URIPARSER_WARNINGS_AS_ERRORS "Treat all compiler warnings as errors" OFF)
 set(URIPARSER_MSVC_RUNTIME "" CACHE STRING "Use of specific runtime library (/MT /MTd /MD /MDd) with MSVC")
 
 if(NOT URIPARSER_BUILD_CHAR AND NOT URIPARSER_BUILD_WCHAR_T)
@@ -103,6 +104,14 @@
     set(URIPARSER_EXTRA_COMPILE_FLAGS "${URIPARSER_EXTRA_COMPILE_FLAGS} -fvisibility=hidden")
 endif()
 
+if(URIPARSER_WARNINGS_AS_ERRORS)
+    if(MSVC)
+        add_definitions(/WX)
+    else()
+        set(URIPARSER_EXTRA_COMPILE_FLAGS "${URIPARSER_EXTRA_COMPILE_FLAGS} -Werror")
+    endif()
+endif()
+
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${URIPARSER_EXTRA_COMPILE_FLAGS}")
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${URIPARSER_EXTRA_COMPILE_FLAGS}")
 
@@ -111,40 +120,40 @@
 #
 check_symbol_exists(wprintf wchar.h HAVE_WPRINTF)
 check_function_exists(reallocarray HAVE_REALLOCARRAY)  # no luck with CheckSymbolExists
-configure_file(src/UriConfig.h.in config.h)
+configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/UriConfig.h.in config.h)
 
 #
 # C library
 #
 set(API_HEADER_FILES
-    include/uriparser/UriBase.h
-    include/uriparser/UriDefsAnsi.h
-    include/uriparser/UriDefsConfig.h
-    include/uriparser/UriDefsUnicode.h
-    include/uriparser/Uri.h
-    include/uriparser/UriIp4.h
+    ${CMAKE_CURRENT_SOURCE_DIR}/include/uriparser/UriBase.h
+    ${CMAKE_CURRENT_SOURCE_DIR}/include/uriparser/UriDefsAnsi.h
+    ${CMAKE_CURRENT_SOURCE_DIR}/include/uriparser/UriDefsConfig.h
+    ${CMAKE_CURRENT_SOURCE_DIR}/include/uriparser/UriDefsUnicode.h
+    ${CMAKE_CURRENT_SOURCE_DIR}/include/uriparser/Uri.h
+    ${CMAKE_CURRENT_SOURCE_DIR}/include/uriparser/UriIp4.h
 )
 set(LIBRARY_CODE_FILES
-    src/UriCommon.c
-    src/UriCommon.h
-    src/UriCompare.c
-    src/UriEscape.c
-    src/UriFile.c
-    src/UriIp4Base.c
-    src/UriIp4Base.h
-    src/UriIp4.c
-    src/UriMemory.c
-    src/UriMemory.h
-    src/UriNormalizeBase.c
-    src/UriNormalizeBase.h
-    src/UriNormalize.c
-    src/UriParseBase.c
-    src/UriParseBase.h
-    src/UriParse.c
-    src/UriQuery.c
-    src/UriRecompose.c
-    src/UriResolve.c
-    src/UriShorten.c
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/UriCommon.c
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/UriCommon.h
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/UriCompare.c
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/UriEscape.c
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/UriFile.c
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/UriIp4Base.c
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/UriIp4Base.h
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/UriIp4.c
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/UriMemory.c
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/UriMemory.h
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/UriNormalizeBase.c
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/UriNormalizeBase.h
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/UriNormalize.c
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/UriParseBase.c
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/UriParseBase.h
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/UriParse.c
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/UriQuery.c
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/UriRecompose.c
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/UriResolve.c
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/UriShorten.c
 )
 
 add_library(uriparser
@@ -157,7 +166,10 @@
     set_property(TARGET uriparser PROPERTY VERSION ${URIPARSER_SO_CURRENT_MINUS_AGE}.${URIPARSER_SO_AGE}.${URIPARSER_SO_REVISION})
     set_property(TARGET uriparser PROPERTY SOVERSION ${URIPARSER_SO_CURRENT_MINUS_AGE})
     if(WIN32)
-        set_property(TARGET uriparser PROPERTY SUFFIX "-${URIPARSER_SO_CURRENT_MINUS_AGE}${CMAKE_SHARED_LIBRARY_SUFFIX}")
+        set_target_properties(uriparser PROPERTIES
+            OUTPUT_NAME uriparser
+            RUNTIME_OUTPUT_NAME uriparser-${URIPARSER_SO_CURRENT_MINUS_AGE}
+            ARCHIVE_OUTPUT_NAME uriparser)
     endif()
 endif()
 
@@ -214,7 +226,7 @@
 #
 if(URIPARSER_BUILD_TOOLS)
     add_executable(uriparse
-        tool/uriparse.c
+        ${CMAKE_CURRENT_SOURCE_DIR}/tool/uriparse.c
     )
 
     target_link_libraries(uriparse PUBLIC uriparser)
@@ -260,10 +272,10 @@
     find_package(GTest 1.8.0 REQUIRED)
 
     add_executable(testrunner
-        test/FourSuite.cpp
-        test/MemoryManagerSuite.cpp
-        test/test.cpp
-        test/VersionSuite.cpp
+        ${CMAKE_CURRENT_SOURCE_DIR}/test/FourSuite.cpp
+        ${CMAKE_CURRENT_SOURCE_DIR}/test/MemoryManagerSuite.cpp
+        ${CMAKE_CURRENT_SOURCE_DIR}/test/test.cpp
+        ${CMAKE_CURRENT_SOURCE_DIR}/test/VersionSuite.cpp
 
         # These library code files have non-public symbols that the test suite
         # needs to link to, so they appear here as well:
@@ -289,6 +301,15 @@
     target_link_libraries(testrunner PUBLIC
         ${GTEST_BOTH_LIBRARIES}
     )
+
+    # NOTE: uriparser does not use pthreads itself but gtest does
+    find_package(Threads REQUIRED)
+    target_link_libraries(testrunner PRIVATE Threads::Threads)
+
+    if(MSVC)
+        # Specify unwind semantics so that MSVC knowns how to handle exceptions
+        target_compile_options(testrunner PRIVATE /EHsc)
+    endif()
 
     add_test(
         NAME
@@ -305,11 +326,20 @@
 #
 if(URIPARSER_BUILD_DOCS)
     find_package(Doxygen REQUIRED dot doxygen)
-    find_program(QHG_LOCATION
-        NAMES
-            qhelpgenerator
-            qhelpgenerator-qt5  # e.g. CentOS 7
-    )
+
+    set(QHG_LOCATION "" CACHE FILEPATH "Path to qhelpgenerator program (default: auto-detect)")
+    if(NOT QHG_LOCATION)
+        find_package(Qt5Help QUIET)
+        if(TARGET Qt5::qhelpgenerator)
+            get_target_property(QHG_LOCATION Qt5::qhelpgenerator LOCATION)
+            mark_as_advanced(Qt5Core_DIR)
+            mark_as_advanced(Qt5Gui_DIR)
+            mark_as_advanced(Qt5Help_DIR)
+            mark_as_advanced(Qt5Sql_DIR)
+            mark_as_advanced(Qt5Widgets_DIR)
+        endif()
+    endif()
+
     include(FindHTMLHelp)
 
     # Generate Doxyfile
@@ -323,8 +353,8 @@
     else()
         set(GENERATE_QHP NO)
     endif()
-    configure_file(doc/Doxyfile.in doc/Doxyfile @ONLY)
-    configure_file(doc/release.sh.in doc/release.sh @ONLY)
+    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/doc/Doxyfile.in doc/Doxyfile @ONLY)
+    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/doc/release.sh.in doc/release.sh @ONLY)
 
     add_custom_target(doc
         ALL
@@ -332,80 +362,3 @@
             ${DOXYGEN_EXECUTABLE}
             Doxyfile
         WORKING_DIRECTORY
-            ${CMAKE_CURRENT_BINARY_DIR}/doc
-        COMMENT
-            "Generating API documentation with Doxygen"
-        VERBATIM
-    )
-
-    uriparser_install(
-        DIRECTORY
-            ${CMAKE_CURRENT_BINARY_DIR}/doc/html
-        DESTINATION
-            ${CMAKE_INSTALL_DOCDIR}
-    )
-    if(QHG_LOCATION)
-        uriparser_install(
-            FILES
-                ${CMAKE_CURRENT_BINARY_DIR}/doc/uriparser-${PROJECT_VERSION}.qch
-            DESTINATION
-                ${CMAKE_INSTALL_DOCDIR}
-        )
-    endif()
-endif()
-
-#
-# CMake files for find_package(uriparser [..] CONFIG [..])
-#
-configure_package_config_file(
-        cmake/uriparser-config.cmake.in
-        cmake/uriparser-config.cmake
-    INSTALL_DESTINATION
-        ${CMAKE_INSTALL_LIBDIR}/cmake/uriparser-${PROJECT_VERSION}/
-)
-write_basic_package_version_file(
-    cmake/uriparser-config-version.cmake
-    COMPATIBILITY SameMajorVersion  # i.e. semver
-)
-export(
-    TARGETS
-        uriparser
-    FILE
-        cmake/uriparser-targets.cmake  # not going to be installed
-)
-uriparser_install(
-    FILES
-        ${CMAKE_CURRENT_BINARY_DIR}/cmake/uriparser-config.cmake
-        ${CMAKE_CURRENT_BINARY_DIR}/cmake/uriparser-config-version.cmake
-    DESTINATION
-        ${CMAKE_INSTALL_LIBDIR}/cmake/uriparser-${PROJECT_VERSION}/
-)
-uriparser_install(
-    EXPORT
-        uriparser
-    DESTINATION
-        ${CMAKE_INSTALL_LIBDIR}/cmake/uriparser-${PROJECT_VERSION}/
-    NAMESPACE
-        uriparser::
-)
-
-#
-# pkg-config file
-#
-if(NOT MSVC)
-    configure_file(liburiparser.pc.in liburiparser.pc @ONLY)
-    uriparser_install(
-        FILES
-            ${CMAKE_CURRENT_BINARY_DIR}/liburiparser.pc
-        DESTINATION
-            ${CMAKE_INSTALL_LIBDIR}/pkgconfig/
-    )
-endif()
-
-#
-# Summary
-#
-message(STATUS "===========================================================================")
-message(STATUS "")
-message(STATUS "Configuration")
-message(STATUS "  Prefix ............... ${CMAKE_INSTALL_PREFIX}")

=== debian/changelog ===
uriparser (0.9.5+dfsg-2) unstable; urgency=medium

  * Upload to unstable.
  * Declare compliance with Debian Policy 4.6.0.0 (No changes needed).

 -- Jörg Frings-Fürst <debian@jff.email>  Thu, 19 Aug 2021 19:44:00 +0200

uriparser (0.9.5+dfsg-1) experimental; urgency=medium

  * New upstream release:
    - Rebase patches.
    - Fix debain/not-installed.
  * Declare compliance with Debian Policy 4.5.1 (No changes needed).
  * debian/control:
    - Remove Build-Depend dh-exec.
  * debian/copyright:
    - Add year 2021 to myself.

 -- Jörg Frings-Fürst <debian@jff.email>  Mon, 26 Apr 2021 22:19:23 +0200

=== debian/control ===
--- 
+++ 
@@ -5,14 +5,13 @@
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
- dh-exec (>=0.3),
  doxygen,
  graphviz,
  libgtest-dev,
  libqt5sql5-sqlite,
  qtbase5-dev,
  qttools5-dev-tools
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0.0
 Rules-Requires-Root: no
 Homepage: http://uriparser.sourceforge.net
 Vcs-Git: git://jff.email/opt/git/uriparser.git

## uriparser 0.9.6+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -38,14 +38,14 @@
 
 project(uriparser
     VERSION
-        0.9.5
+        0.9.6
     LANGUAGES
         C
 )
 
 # See https://verbump.de/ for what these numbers do
 set(URIPARSER_SO_CURRENT    1)
-set(URIPARSER_SO_REVISION  28)
+set(URIPARSER_SO_REVISION  29)
 set(URIPARSER_SO_AGE        0)
 
 include(CheckCCompilerFlag)
@@ -78,6 +78,11 @@
     message(SEND_ERROR "URIPARSER_BUILD_TOOLS=ON requires URIPARSER_BUILD_CHAR=ON.")
 endif()
 
+if(URIPARSER_BUILD_TESTS)
+    # We have to call enable_language() before modifying any CMAKE_CXX_* variables
+    enable_language(CXX)
+endif()
+
 macro(uriparser_apply_msvc_runtime_to ref)
     string(REGEX REPLACE "/M[DT]d?" ${URIPARSER_MSVC_RUNTIME} ${ref} "${${ref}}")
 endmacro()
@@ -103,17 +108,6 @@
 if(URIPARSER_COMPILER_SUPPORTS_VISIBILITY)
     set(URIPARSER_EXTRA_COMPILE_FLAGS "${URIPARSER_EXTRA_COMPILE_FLAGS} -fvisibility=hidden")
 endif()
-
-if(URIPARSER_WARNINGS_AS_ERRORS)
-    if(MSVC)
-        add_definitions(/WX)
-    else()
-        set(URIPARSER_EXTRA_COMPILE_FLAGS "${URIPARSER_EXTRA_COMPILE_FLAGS} -Werror")
-    endif()
-endif()
-
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${URIPARSER_EXTRA_COMPILE_FLAGS}")
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${URIPARSER_EXTRA_COMPILE_FLAGS}")
 
 #
 # config.h
@@ -259,8 +253,6 @@
 # C++ test runner
 #
 if(URIPARSER_BUILD_TESTS)
-    enable_language(CXX)
-
     if(MSVC AND URIPARSER_MSVC_RUNTIME)
         uriparser_apply_msvc_runtime_to(CMAKE_CXX_FLAGS)
         uriparser_apply_msvc_runtime_to(CMAKE_CXX_FLAGS_DEBUG)
@@ -286,6 +278,7 @@
     target_compile_definitions(testrunner PRIVATE URI_STATIC_BUILD)
 
     if(MSVC)
+        target_compile_definitions(testrunner PRIVATE -D_CRT_NONSTDC_NO_WARNINGS)
         target_compile_definitions(testrunner PRIVATE -D_CRT_SECURE_NO_WARNINGS)
     endif()
 
@@ -309,17 +302,37 @@
     if(MSVC)
         # Specify unwind semantics so that MSVC knowns how to handle exceptions
         target_compile_options(testrunner PRIVATE /EHsc)
+    endif()
+
+    if(MINGW)
+        set(_URIPARSER_TEST_COMMAND wine testrunner)
+    else()
+        set(_URIPARSER_TEST_COMMAND      testrunner)
     endif()
 
     add_test(
         NAME
             test
         COMMAND
-            testrunner
+            ${_URIPARSER_TEST_COMMAND}
     )
 
     add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})
 endif()
+
+#
+# Compiler flags
+#
+if(URIPARSER_WARNINGS_AS_ERRORS)
+    if(MSVC)
+        add_definitions(/WX)
+    else()
+        set(URIPARSER_EXTRA_COMPILE_FLAGS "${URIPARSER_EXTRA_COMPILE_FLAGS} -Werror")
+    endif()
+endif()
+
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${URIPARSER_EXTRA_COMPILE_FLAGS}")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${URIPARSER_EXTRA_COMPILE_FLAGS}")
 
 #
 # Doxygen API documentation
@@ -350,15 +363,3 @@
     endif()
     if(QHG_LOCATION)
         set(GENERATE_QHP YES)
-    else()
-        set(GENERATE_QHP NO)
-    endif()
-    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/doc/Doxyfile.in doc/Doxyfile @ONLY)
-    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/doc/release.sh.in doc/release.sh @ONLY)
-
-    add_custom_target(doc
-        ALL
-        COMMAND
-            ${DOXYGEN_EXECUTABLE}
-            Doxyfile
-        WORKING_DIRECTORY

=== debian/changelog ===
uriparser (0.9.6+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Fix for CVE-2021-46141 and CVE-2021-46142.
  * Fix debian/not-installed.
  * debian/copyright:
    - Add year 2022 to myself.
  * Declare compliance with Debian Policy 4.6.0.1 (No changes needed).

 -- Jörg Frings-Fürst <debian@jff.email>  Sun, 09 Jan 2022 19:53:25 +0100

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  libqt5sql5-sqlite,
  qtbase5-dev,
  qttools5-dev-tools
-Standards-Version: 4.6.0.0
+Standards-Version: 4.6.0.1
 Rules-Requires-Root: no
 Homepage: http://uriparser.sourceforge.net
 Vcs-Git: git://jff.email/opt/git/uriparser.git

## uriparser 0.9.7+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -38,14 +38,14 @@
 
 project(uriparser
     VERSION
-        0.9.6
+        0.9.7
     LANGUAGES
         C
 )
 
 # See https://verbump.de/ for what these numbers do
 set(URIPARSER_SO_CURRENT    1)
-set(URIPARSER_SO_REVISION  29)
+set(URIPARSER_SO_REVISION  30)
 set(URIPARSER_SO_AGE        0)
 
 include(CheckCCompilerFlag)
@@ -110,11 +110,11 @@
 endif()
 
 #
-# config.h
+# UriConfig.h
 #
 check_symbol_exists(wprintf wchar.h HAVE_WPRINTF)
 check_function_exists(reallocarray HAVE_REALLOCARRAY)  # no luck with CheckSymbolExists
-configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/UriConfig.h.in config.h)
+configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/UriConfig.h.in UriConfig.h)
 
 #
 # C library
@@ -193,7 +193,7 @@
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
         $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
     PRIVATE
-        ${CMAKE_CURRENT_BINARY_DIR}  # for config.h
+        ${CMAKE_CURRENT_BINARY_DIR}  # for UriConfig.h
 )
 
 uriparser_install(
@@ -288,7 +288,7 @@
 
     target_include_directories(testrunner PRIVATE
         ${CMAKE_CURRENT_SOURCE_DIR}/include
-        ${CMAKE_CURRENT_BINARY_DIR}  # for config.h
+        ${CMAKE_CURRENT_BINARY_DIR}  # for UriConfig.h
     )
 
     target_link_libraries(testrunner PUBLIC
@@ -362,4 +362,3 @@
         set(GENERATE_HTMLHELP NO)
     endif()
     if(QHG_LOCATION)
-        set(GENERATE_QHP YES)

=== debian/changelog ===
uriparser (0.9.7+dfsg-2build1) noble; urgency=high

  * No change rebuild for frame pointers (and time_t).

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 18 Apr 2024 19:50:40 +0200

uriparser (0.9.7+dfsg-2) unstable; urgency=medium

  * debian/liburiparser-dev.install:
    - Add usr/lib/*/cmake/uriparser-* (Closes: +1029143).
  * Declare compliance with Debian Policy 4.6.2.0 (No changes needed).
  * debian/copyright:
    - Add year 2023 to myself.

 -- Jörg Frings-Fürst <debian@jff.email>  Sun, 29 Jan 2023 12:36:36 +0100

uriparser (0.9.7+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Fix debian/watch.
  * Declare compliance with Debian Policy 4.6.1.0 (No changes needed).

 -- Jörg Frings-Fürst <debian@jff.email>  Sat, 29 Oct 2022 23:03:54 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: uriparser
 Section: libs
 Priority: optional
-Maintainer: Jörg Frings-Fürst <debian@jff.email>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Jörg Frings-Fürst <debian@jff.email>
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
@@ -11,7 +12,7 @@
  libqt5sql5-sqlite,
  qtbase5-dev,
  qttools5-dev-tools
-Standards-Version: 4.6.0.1
+Standards-Version: 4.6.2.0
 Rules-Requires-Root: no
 Homepage: http://uriparser.sourceforge.net
 Vcs-Git: git://jff.email/opt/git/uriparser.git

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

# hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Configure arguments

confflags = --prefix=/usr --disable-test --disable-doc --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)

DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

confflags += --build $(DEB_BUILD_GNU_TYPE)

# Only specify --host when cross-compiling
ifneq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
	confflags += --host $(DEB_HOST_GNU_TYPE)
endif

export QT_SELECT=qt5

%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake

override_dh_auto_build-indep:
	dh_auto_build

override_dh_installdocs-indep:
	cp -r $(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)/doc/html/* $(CURDIR)/debian/liburiparser-doc/usr/share/doc/liburiparser-doc/html/
	$(RM) debian/liburiparser-doc/usr/share/doc/liburiparser-doc/html/*.md5
	dh_installdocs

override_dh_makeshlibs:
	dh_makeshlibs -- -v$(DEB_VERSION_UPSTREAM) -Pdebian/liburiparser1 -pliburiparser1

override_dh_compress:
	dh_compress -X.qhp

## uriparser 0.9.8+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -34,18 +34,18 @@
 # ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 # OF THE POSSIBILITY OF SUCH DAMAGE.
 #
-cmake_minimum_required(VERSION 3.3)
+cmake_minimum_required(VERSION 3.5.0)
 
 project(uriparser
     VERSION
-        0.9.7
+        0.9.8
     LANGUAGES
         C
 )
 
 # See https://verbump.de/ for what these numbers do
 set(URIPARSER_SO_CURRENT    1)
-set(URIPARSER_SO_REVISION  30)
+set(URIPARSER_SO_REVISION  31)
 set(URIPARSER_SO_AGE        0)
 
 include(CheckCCompilerFlag)
@@ -58,7 +58,12 @@
 #
 # Configuration
 #
-option(BUILD_SHARED_LIBS "Build shared libraries (rather than static ones)" ON)
+if(DEFINED BUILD_SHARED_LIBS)
+    set(_URIPARSER_SHARED_LIBS_DEFAULT ${BUILD_SHARED_LIBS})
+else()
+    set(_URIPARSER_SHARED_LIBS_DEFAULT ON)
+endif()
+option(URIPARSER_SHARED_LIBS "Build shared libraries (rather than static ones)" ${_URIPARSER_SHARED_LIBS_DEFAULT})
 option(URIPARSER_BUILD_DOCS "Build API documentation (requires Doxygen, Graphviz, and (optional) Qt's qhelpgenerator)" ON)
 option(URIPARSER_BUILD_TESTS "Build test suite (requires GTest >=1.8.0)" ON)
 option(URIPARSER_BUILD_TOOLS "Build tools (e.g. CLI \"uriparse\")" ON)
@@ -81,6 +86,12 @@
 if(URIPARSER_BUILD_TESTS)
     # We have to call enable_language() before modifying any CMAKE_CXX_* variables
     enable_language(CXX)
+endif()
+
+if(URIPARSER_SHARED_LIBS)
+    set(_URIPARSER_STATIC_OR_SHARED SHARED)
+else()
+    set(_URIPARSER_STATIC_OR_SHARED STATIC)
 endif()
 
 macro(uriparser_apply_msvc_runtime_to ref)
@@ -151,6 +162,7 @@
 )
 
 add_library(uriparser
+    ${_URIPARSER_STATIC_OR_SHARED}
     ${API_HEADER_FILES}
     ${LIBRARY_CODE_FILES}
 )
@@ -175,7 +187,7 @@
 )
 
 target_compile_definitions(uriparser PRIVATE URI_LIBRARY_BUILD)
-if (NOT BUILD_SHARED_LIBS)
+if (NOT URIPARSER_SHARED_LIBS)
     target_compile_definitions(uriparser PUBLIC URI_STATIC_BUILD)
 endif()
 if(NOT URIPARSER_BUILD_CHAR)
@@ -347,18 +359,3 @@
             get_target_property(QHG_LOCATION Qt5::qhelpgenerator LOCATION)
             mark_as_advanced(Qt5Core_DIR)
             mark_as_advanced(Qt5Gui_DIR)
-            mark_as_advanced(Qt5Help_DIR)
-            mark_as_advanced(Qt5Sql_DIR)
-            mark_as_advanced(Qt5Widgets_DIR)
-        endif()
-    endif()
-
-    include(FindHTMLHelp)
-
-    # Generate Doxyfile
-    if(HTML_HELP_COMPILER)
-        set(GENERATE_HTMLHELP YES)
-    else()
-        set(GENERATE_HTMLHELP NO)
-    endif()
-    if(QHG_LOCATION)

=== cmake/test_find_package/CMakeLists.txt ===
# uriparser - RFC 3986 URI parsing library
#
# Copyright (C) 2018, Sebastian Pipping <sebastian@pipping.org>
# All rights reserved.
#
# Redistribution and use in source  and binary forms, with or without
# modification, are permitted provided  that the following conditions
# are met:
#
#     1. Redistributions  of  source  code   must  retain  the  above
#        copyright notice, this list  of conditions and the following
#        disclaimer.
#
#     2. Redistributions  in binary  form  must  reproduce the  above
#        copyright notice, this list  of conditions and the following
#        disclaimer  in  the  documentation  and/or  other  materials
#        provided with the distribution.
#
#     3. Neither the  name of the  copyright holder nor the  names of
#        its contributors may be used  to endorse or promote products
#        derived from  this software  without specific  prior written
#        permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND  ANY EXPRESS OR IMPLIED WARRANTIES,  INCLUDING, BUT NOT
# LIMITED TO,  THE IMPLIED WARRANTIES OF  MERCHANTABILITY AND FITNESS
# FOR  A  PARTICULAR  PURPOSE  ARE  DISCLAIMED.  IN  NO  EVENT  SHALL
# THE  COPYRIGHT HOLDER  OR CONTRIBUTORS  BE LIABLE  FOR ANY  DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO,  PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA,  OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT  LIABILITY,  OR  TORT (INCLUDING  NEGLIGENCE  OR  OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#
cmake_minimum_required(VERSION 3.5.0)

project(test-find-package VERSION 1.0)


# Cover version mismatch
find_package(uriparser 9999 CONFIG QUIET)
if (uriparser_FOUND)
    message(SEND_ERROR "Was not expecting for find uriparser 9999.x.x")
endif()


# Cover invalid required component
find_package(uriparser 0.9.1 CONFIG QUIET
    COMPONENTS
        invalid123
)
if (uriparser_FOUND)
    message(SEND_ERROR "Was not expecting for find uriparser with component \"invalid123\"")
endif()


# Cover invalid optional component
find_package(uriparser 0.9.1 CONFIG REQUIRED
    COMPONENTS
        char
        wchar_t
    OPTIONAL_COMPONENTS
        invalid123
)
if (NOT uriparser_FOUND)
    message(SEND_ERROR "Was expecting to find uriparser. Something is off.")
endif()


# Compile and link some hello world using uriparser
add_executable(hello
    hello.c
)

target_link_libraries(hello PUBLIC uriparser::uriparser)

=== debian/changelog ===
uriparser (0.9.8+dfsg-2) unstable; urgency=medium

  * debian/control:
    - Fix Vcs-Git URL.
  * Declare compliance with Debian Policy 4.7.0.1 (No changes needed).
  * debian/copyright:
    - Rewrite to make lrc happy.
    - Add Upstream-Contact.
  * debian/patches/0001-missing_pthread.patch:
    - Add Forwarded: not-needed.

 -- Jörg Frings-Fürst <debian@jff.email>  Wed, 13 Nov 2024 18:57:53 +0100

uriparser (0.9.8+dfsg-1) unstable; urgency=medium

  * New upstream release:
    - Fixes CVE-2024-34402, CVE-2024-34403 (Closes: #1070376).
  * debian/changelog:
    - Add year 2024 to myself.
  * debian/control:
    - Change to new repository URL.
  * Declare compliance with Debian Policy 4.7.0 (No changes needed).

 -- Jörg Frings-Fürst <debian@jff.email>  Thu, 11 Jul 2024 16:49:54 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: uriparser
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Jörg Frings-Fürst <debian@jff.email>
+Maintainer: Jörg Frings-Fürst <debian@jff.email>
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
@@ -12,11 +11,11 @@
  libqt5sql5-sqlite,
  qtbase5-dev,
  qttools5-dev-tools
-Standards-Version: 4.6.2.0
+Standards-Version: 4.7.0.1
 Rules-Requires-Root: no
-Homepage: http://uriparser.sourceforge.net
-Vcs-Git: git://jff.email/opt/git/uriparser.git
-Vcs-Browser: https://jff.email/cgit/uriparser.git
+Homepage: https://uriparser.github.io/
+Vcs-Git: https://git.jff.email/cgit/uriparser.git
+Vcs-Browser: https://git.jff.email/cgit/uriparser.git
 
 Package: liburiparser1
 Architecture: any

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg.*$//,filenamemangle=s/.+\/[vV]?(\d\S+)\.tar\.gz/uriparser-$1\.tar\.gz/,repack,repacksuffix=+dfsg," \
https://github.com/uriparser/uriparser/tags .*[^n]/(?:|v|version-|version|release-|r|REL_|rel-|uriparser(?:_|-))(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
